<?php

use yii\bootstrap\ActiveForm;
use yii\helpers\Html;

use app\models\Product;

?>

<link href="/css/pages/product.css" rel="stylesheet">

<div id="page_product" class="container mb-auto">
    <div class="row py-3">
        <article class="col-12">
            <div class="p-3 d-flex flex-column rounded">
                <div id="product_slider" class="row px-3 profile_panel">
                    <div class="col-1 product_slider_preview p-0 pr-3 mb-3">
                        <?php
                        foreach ($model['imgs'] ?? [null] as $key => $image) {
                            // Перебор изображений

                            // Инициализация
                            $h150 = $image['h150'] ?? '/img/covers/h150/product.png';

                            // Генерация предпросмотра изображения
                            echo <<<HTML
                                    <label class="p-0 mb-2" for="product_slider_image_$key">
                                    <img class="img-fluid rounded" src="$h150"/>
                                </label>
                            HTML;
                        }
                        ?>

                        <?php if (
                            !yii::$app->user->isGuest
                            && (yii::$app->user->identity->type === 'administrator'
                                || yii::$app->user->identity->type === 'moderator')
                        ) : ?>
                            <input id="product_slider_image_new" type="file" class="d-none" onchange="return product_panel_images_write('<?= $model['catn'] ?>', this);" multiple />
                            <label class="p-0 mb-2" for="product_slider_image_new" role="button">
                                <img class="img-fluid rounded" src="/img/covers/h150/product_new.png" />
                            </label>
                        <?php endif ?>
                    </div>
                    <div class="product_slider_image">
                        <?php
                        // Инициализация
                        $imgs = $model['imgs'] ?? [null];
                        $checked = '';

                        foreach ($model['imgs'] ?? [null] as $key => $image) {
                            // Перебор изображений

                            // Инициализация
                            $name = $image['name'] ?? 'Без названия';
                            $orig = $image['orig'] ?? '/img/covers/product.png';
                            $covr = $image['covr'] ?? false;

                            if ($covr || count($imgs) < 2) {
                                // Если это изображение является обложкой

                                // Реинициализация
                                $checked = 'checked';
                            }

                            // Генерация изображения
                            echo <<<HTML
                                <input type="radio" id="product_slider_image_$key" name="slider" $checked/>
                                <div class="col p-0">
                                    <img class="img-fluid rounded" src="$orig"/>
                                </div>
                            HTML;

                            // Деинициализация
                            $checked = '';
                        }
                        ?>
                    </div>
                    <div class="col ml-4 d-flex flex-column">
                        <div class="row mb-1">
                            <?php if (
                                !yii::$app->user->isGuest
                                && (yii::$app->user->identity->type === 'administrator'
                                    || yii::$app->user->identity->type === 'moderator')
                            ) : ?>
                                <h3 id="title_<?= $model['catn'] ?>" class="my-auto pointer-event" role="button" onclick="return product_panel_title_edit('<?= $model['catn'] ?>', this);"><?= $model['name'] ?? 'Без названия' ?></h3>
                            <?php else : ?>
                                <h3 id="title_<?= $model['catn'] ?>" class="my-auto"><?= $model['name'] ?? 'Без названия' ?></h3>
                            <?php endif ?>

                            <?php if (
                                !yii::$app->user->isGuest
                                && (yii::$app->user->identity->type === 'administrator'
                                    || yii::$app->user->identity->type === 'moderator')
                            ) : ?>
                                <h5 id="catn_<?= $model['catn'] ?>" class="ml-auto my-auto d-flex pointer-event" role="button" onclick="return product_panel_catn_edit('<?= $model['catn'] ?>', this, true);">
                                    <?= $model['catn'] ?>
                                    <!-- <small class="d-flex">
                                        <a class="text-dark my-auto ml-3" title="Редактировать" role="button" onclick="return product_panel_edit('<?= $model['catn'] ?>');">
                                            <i class="fas fa-edit"></i>
                                        </a>
                                        <a class="text-dark my-auto ml-2" title="Удалить" role="button" onclick="return product_panel_delete('<?= $model['catn'] ?>');">
                                            <i class="fas fa-trash-alt"></i>
                                        </a>
                                    </small> -->
                                </h5>
                            <?php else : ?>
                                <h5 id="catn_<?= $model['catn'] ?>" class="ml-auto my-auto d-flex">
                                    <?= $model['catn'] ?>
                                </h5>
                            <?php endif ?>
                        </div>
                        <div class="dropdown-divider px-0 mb-3"></div>
                        <div class="row mb-3 h-100 product_panel d-flex flex-column">
                            <?php if (
                                !yii::$app->user->isGuest
                                && (yii::$app->user->identity->type === 'administrator'
                                    || yii::$app->user->identity->type === 'moderator')
                            ) : ?>
                                <p id="description_<?= $model['catn'] ?>" class="mt-0 ml-0 text-break pointer-event product_description" role="button" onclick="return product_panel_description_edit('<?= $model['catn'] ?>', this);"><?= $model['desc'] ?? 'Без описания' ?></p>
                            <?php else : ?>
                                <p id="description_<?= $model['catn'] ?>" class="mt-0 ml-0 text-break product_description"><?= $model['name'] ?? 'Без описания' ?></p>
                            <?php endif ?>
                            <p class="mt-0">
                                <?php
                                // foreach ($model['catn'] ?? [] as $catn) {
                                //     echo <<<HTML
                                //         $catn
                                //     HTML;
                                // }
                                ?>
                            </p>
                        </div>
                        <?php
                        $form = ActiveForm::begin([
                            'id' => 'form_product_cart',
                            'action' => false,
                            'fieldConfig' => [
                                'template' => '{input}',
                            ],
                            'options' => [
                                'onsubmit' => 'return false;',
                                'class' => 'row mt-auto'
                            ]
                        ]);

                        // Просто для теста
                        $model = new Product();
                        ?>

                        <div class="col-6 px-0 mr-4 btn-group">
                            <?= Html::submitButton('В корзину', ['name' => 'cartWrite', 'onclick' => 'product_cart_write(this.parentElement);', 'class' => 'col-10 btn button_blue button_clean py-2 px-5']) ?>
                            <?= $form->field($model, 'amount', ['options' => ['class' => 'col h-100 m-0 form-group']])->textInput(['value' => '1', 'class' => 'form-control h-100 rounded-0 text-center button_clean']); ?>
                        </div>

                        <div>
                            <p class="mt-0">
                                <strong>Хабаровск: </strong>
                                в наличии
                            </p>
                            <p class="mb-0">
                                Доставим: завтра
                            </p>
                        </div>

                        <?php ActiveForm::end(); ?>
                    </div>
                </div>

                <!-- <div class="row mt-3 mx-0">
                    <p class="ml-0">Время для повышения релевантности в поисковиках</p>
                    <time class="ml-auto"></time>
                </div> -->
            </div>
        </article>
    </div>
</div>

<script src="/js/product.js" defer></script>
<?php if (
    !yii::$app->user->isGuest
    && (yii::$app->user->identity->type === 'administrator'
        || yii::$app->user->identity->type === 'moderator')
) : ?>
    <script src="/js/product_panel.js" defer></script>
<?php endif ?>