function product_panel_title_edit(catn, element) {
    if (catn !== null && catn !== undefined && element !== null && element !== undefined) {
        element.innerHTML = '<input class="form-control text-center" type="text" value="' + element.innerText + '" onchange="return product_panel_title_save(\'' + catn + '\', this.parentElement)" aria-invalid="false">';

        element.removeAttribute('onclick');

        return false;
    }

    return true;
}

function product_panel_title_save(catn, element) {
    if (catn !== null && catn !== undefined && element !== null && element !== undefined) {
        // Инициализация
        let text = element.children[0].value;

        // Обновление заголовка (предзагрузка)
        element.innerHTML = text;

        // Запись аттрибута (предзагрузка)
        element.setAttribute('onclick', 'return product_panel_title_edit(\'' + catn + '\', this);');

        $.ajax({
            url: '/product/' + catn + '/edit/title',
            type: 'post',
            dataType: 'json',
            data: {
                '_csrf': yii.getCsrfToken(),
                'text': text
            },
            success: function (data, status) {
                // Заголовок
                if (data.name !== undefined && element !== null && element !== undefined) {
                    // Обновление заголовка
                    element.innerHTML = data.name;

                    // Запись аттрибута
                    element.setAttribute('onclick', 'return product_panel_title_edit(\'' + catn + '\', this);');
                };

                product_response_success(data, status);
            },
            error: product_response_error
        });

        return false;
    }

    return true;
}

function product_panel_catn_edit(catn, element, redirect = false) {
    if (catn !== null && catn !== undefined && element !== null && element !== undefined) {
        element.innerHTML = '<input class="form-control text-center" type="text" value="' + element.innerText + '" onchange="return product_panel_catn_save(\'' + catn + '\', this.parentElement, ' + redirect + ')" aria-invalid="false">';

        element.removeAttribute('onclick');

        return false;
    }

    return true;
}

function product_panel_catn_save(catn, element, redirect = false) {
    if (catn !== null && catn !== undefined && element !== null && element !== undefined) {
        // Инициализация
        let text = element.children[0].value;

        // Обновление заголовка (предзагрузка)
        element.innerHTML = text;

        // Запись аттрибута (предзагрузка)
        element.setAttribute('onclick', 'return product_panel_catn_edit(\'' + catn + '\', this);');

        $.ajax({
            url: '/product/' + catn + '/edit/catn',
            type: 'post',
            dataType: 'json',
            data: {
                '_csrf': yii.getCsrfToken(),
                'text': text
            },
            success: function (data, status) {
                // Заголовок
                if (data.catn !== undefined && element !== null && element !== undefined) {
                    if (redirect) {
                        // Перенаправление
                        history.pushState({}, '/product/' + catn, '/product/' + data.catn);
                    }
                };

                product_response_success(data, status);
            },
            error: product_response_error
        });

        return false;
    }

    return true;
}

function product_panel_description_edit(catn, element) {
    if (catn !== null && catn !== undefined && element !== null && element !== undefined) {
        element.innerHTML = '<textarea class="form-control" cols="50" rows="5" onchange = "return product_panel_description_save(\'' + catn + '\', this.parentElement)">' + element.innerText + '</textarea>';

        element.removeAttribute('onclick');

        return false;
    }

    return true;
}

function product_panel_description_save(catn, element) {
    if (catn !== null && catn !== undefined && element !== null && element !== undefined) {
        // Инициализация
        let text = element.children[0].value;

        // Обновление заголовка (предзагрузка)
        element.innerHTML = text;

        // Запись аттрибута (предзагрузка)
        element.setAttribute('onclick', 'return product_panel_description_edit(\'' + catn + '\', this);');

        $.ajax({
            url: '/product/' + catn + '/edit/desc',
            type: 'post',
            dataType: 'json',
            data: {
                '_csrf': yii.getCsrfToken(),
                'text': text
            },
            success: function (data, status) {
                // Заголовок
                if (data.description !== undefined && element !== null && element !== undefined) {
                    // Обновление заголовка
                    element.innerHTML = data.description;

                    // Запись аттрибута
                    element.setAttribute('onclick', 'return product_panel_description_edit(\'' + catn + '\', this);');
                };

                product_response_success(data, status);
            },
            error: product_response_error
        });

        return false;
    }

    return true;
}

function product_panel_images_write(catn, element) {
    if (catn !== null && catn !== undefined && element !== null && element !== undefined) {
        // Инициализация
        let data = new FormData();

        data.append('_csrf', yii.getCsrfToken());
        for (i = 0; i < element.files.length; i++) {
            data.append('images[' + i + ']', element.files[i]);
        }

        $.ajax({
            url: '/product/' + catn + '/write/image',
            type: 'post',
            dataType: 'json',
            processData: false,
            contentType: false,
            data: data,
            success: product_response_success,
            error: product_response_error
        });

        return false;
    }

    return true;
}